%define momorel 2

Name: java-common
Version: 0.7
Release: %{momorel}m
Summary: Momonga's directory structure and tools for Java.
Group: Development/Tools
URL: http://www.momonga-linux.org/
License: BSD
Requires: ruby, mailcap
PreReq: chkconfig
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root

Source0: java-config
%define javaconfig_command %{SOURCE0}

Source1: java-config.rb
%define javaconfig_lib %{SOURCE1}

Source2: javadoc.conf
%define javadocconf %{SOURCE2}

Source3: index.cgi
%define indexcgi %{SOURCE3}

Source4: index.html.in
%define indexhtmlin %{SOURCE4}

Source5: stylesheet.css
%define stylesheetcss %{SOURCE5}

%description
Momonga's directory structure and tools for Java.
It currently includes:
  - java-config

%package httpd
Summary: Apache HTTPD configuration for browsing javadocs
Group: System Environment/Base
Requires: java-common = %{version}-%{release}
Requires: httpd initscripts ruby-amrita

%description httpd
This package provides an Apache HTTPD configuration file
which enables browsing javadocs via http://localhost/javadoc/.

%define begin_mark # BEGIN: Java Web Start
%define end_mark # END: Java Web Start
%define mailcap %{_sysconfdir}/mailcap
%define mime_types %{_sysconfdir}/mime.types

%define mime_type application/x-java-jnlp-file
%define mime_handler %{_bindir}/javaws %s
%define mime_desc  Java Web Start
%define mime_ext jnlp
%define mailcap_line %{mime_type}; %{mime_handler}
%define mime_types_line type=%{mime_type} desc="%{mime_desc}" exts=%{mime_ext}

%prep
:

%build
:

%install
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%__mkdir_p %{buildroot}%{_bindir}
%__mkdir_p %{buildroot}%{_libdir}/java
%__mkdir_p %{buildroot}%{_libdir}/java/jni
%__mkdir_p %{buildroot}%{_datadir}/java
%__mkdir_p %{buildroot}%{_datadir}/java/ext
%__mkdir_p %{buildroot}%{_datadir}/java/java-config
%__mkdir_p %{buildroot}%{_datadir}/javadoc
%__mkdir_p %{buildroot}%{_sysconfdir}/.java/.systemPrefs
%__mkdir_p %{buildroot}%{_sysconfdir}/java
%__mkdir_p %{buildroot}%{_sysconfdir}/java/alternatives
%__mkdir_p %{buildroot}%{_sysconfdir}/java/ext
%__mkdir_p %{buildroot}%{_sysconfdir}/java/jni
%__mkdir_p %{buildroot}%{_sysconfdir}/java/classpath
%__mkdir_p %{buildroot}%{_sysconfdir}/httpd/conf.d

%__install -m 755 %{javaconfig_command} %{buildroot}%{_bindir}
%__install -m 644 %{javaconfig_lib}     %{buildroot}%{_datadir}/java/java-config
%__install -m 644 %{javadocconf} 	%{buildroot}%{_sysconfdir}/httpd/conf.d/javadoc.conf.dist
%__install -m 755 %{indexcgi}           %{buildroot}%{_datadir}/javadoc
%__install -m 644 %{indexhtmlin}        %{buildroot}%{_datadir}/javadoc
%__install -m 644 %{stylesheetcss}      %{buildroot}%{_datadir}/javadoc

%clean
[ "%{buildroot}" != "/" ] && %__rm -rf %{buildroot}

%post
[ $1 = 1 ] || exit 0
%__sed '/^%{begin_mark}/,/^%{end_mark}/d' %{mailcap} > /tmp/mailcap.$$ && \
	%__mv /tmp/mailcap.$$ %{mailcap}

cat >> %{mailcap} <<EOT
%{begin_mark}
%{mailcap_line}
%{end_mark}
EOT

%__sed '/^%{begin_mark}/,/^%{end_mark}/d' %{mime_types} > /tmp/mime.types.$$ && \
	%__mv /tmp/mime.types.$$ %{mime_types}

cat >> %{mime_types} <<EOT
%{begin_mark}
%{mime_types_line}
%{end_mark}
EOT
exit 0
#---------------------------------------------------------------------------
%postun
[ $1 = 0 ] || exit 0
%__sed '/^%{begin_mark}/,/^%{end_mark}/d' %{mailcap} > /tmp/mailcap.$$ && \
	%__mv /tmp/mailcap.$$ %{mailcap}

%__sed '/^%{begin_mark}/,/^%{end_mark}/d' %{mime_types} > /tmp/mime.types.$$ && \
	%__mv /tmp/mime.types.$$ %{mime_types}
exit 0

%post httpd
if [ -f /var/run/httpd.pid ]; then
  PID=`cat /var/run/httpd.pid`
  if [ -n "$PID" ]; then
    if [ -d /proc/$PID ]; then
      /sbin/service httpd reload
    fi
  fi
fi

%postun httpd
if [ -f /var/run/httpd.pid ]; then
  PID=`cat /var/run/httpd.pid`
  if [ -n "$PID" ]; then
    if [ -d /proc/$PID ]; then
      /sbin/service httpd reload
    fi
  fi
fi

%files
%defattr(-,root,root)
%dir %{_libdir}/java
%dir %{_libdir}/java/jni
%dir %{_datadir}/java
%dir %{_datadir}/java/ext
%dir %{_datadir}/java/java-config
%dir %{_datadir}/javadoc
%dir %{_sysconfdir}/java
%dir %{_sysconfdir}/java/alternatives
%dir %{_sysconfdir}/java/classpath
%dir %{_sysconfdir}/java/ext
%dir %{_sysconfdir}/java/jni
%dir %{_sysconfdir}/.java
%dir %{_sysconfdir}/.java/.systemPrefs
%{_datadir}/java/java-config/java-config.rb
%{_bindir}/java-config

%files httpd
%defattr(-,root,root)
%config %{_sysconfdir}/httpd/conf.d/javadoc.conf.dist
%{_datadir}/javadoc/index.cgi
%{_datadir}/javadoc/index.html.in
%{_datadir}/javadoc/stylesheet.css

%changelog
* Tue Aug 17 2004 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.7-1m)
- add jni directory support

* Mon Jul 19 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.6-3m)
- stop javadoc service

* Fri Jul 16 2004 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.6-2m)
- fix bug of <Files> directive in httpd configuration.

* Sun Oct  5 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.6-1m)
- add --remove-extensions.

* Sun Oct  5 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.5-1m)
- add --update-extensions.

* Sat Oct  4 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.4-2m)
- now owns /etc/.java/.systemPrefs
- fix httpd reload stuff.
- add index.cgi in /javadoc.

* Thu Sep 25 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.4-1m)
- add httpd configuration(subpackage).

* Thu Sep 25 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.3-3m)
- use flatten instead of join.

* Thu Sep 25 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.3-2m)
- should run 'alternatives --auto' after --remove-alternatives.

* Wed Sep 24 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.3-1m)
- move java-config.rb to my own directory.

* Mon Sep 22 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.2-1m)
- add classpath stuff.

* Mon Sep 22 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.1-2m)
- handles webstart.
- handle empty slave of alternatives.

* Sun Sep 21 2003 OZAWA Sakuro <crouton@momonga-linux.org>
- (0.1-1m)
- initial release.
